[ORG 0x10000]
[BITS 16] ;
segment .text
START:
	mov ax, 0x1000 ; 시작 주소 설정
	mov ds, ax
	mov es, ax
	
	mov ax, 0x2401
	int 0x15
	
	jc .A20ERR
	jmp .A20OK

.A20ERR:
	in al, 0x92
	or al, 0x02
	and al, 0xFE
	out 0x92, al

.A20OK:
	mov eax, 0x4000003B ; CR0 컨트롤 레지스터 설정
	mov cr0, eax ;
	lgdt [GDTR]; GDTR 레지스터에 테이블 주소 설정

	jmp dword 0x08: PROTECTEDMODE
[BITS 32]
PROTECTEDMODE:
	mov ax, 0x10
	mov ds, ax
	mov es, ax
	mov fs, ax
	mov gs, ax
	mov ss, ax
	mov esp, 0xFFFE
	mov ebp, 0xFFFE
	lidt[IDTR]
	jmp dword 0x08: 0x10A00 ; C 커널로 점프

IDTR:
	dw 256*8-1
	dd IDT

IDT:
	; 1번
	IDT_DIVISION_BY_ZERO:
	dw INTERRUPT_NOTHING	; 주소1
	dw 0x08			; 0x08 : 코드 세그먼트 셀렉터의 GDT에서의 오프셋

	db 0x00			; Unused
	db 0x8E			; TYPE, FLAGS
	dw 0x0001		; 주소 2

	; 2번
	IDT_DEBUG_MODE:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 3번
	IDT_NMI: ; non-maskable-interrupt
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 4번
	IDT_SLAVE_PIN:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001
	
	; 5번
	IDT_OVERFLOW:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001
	
	; 6번
	IDT_INVALID_ADDRESS:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 7번
	IDT_UNKNOWN_COMMAND:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 8번
	IDT_UNKNOWN_DEVICE:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 9번
	IDT_CONNECTED_UNHANDLEABLE_EXCEPTION:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 10
	IDT_COPROCESSOR_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001
	
	; 11번
	IDT_INVALID_TSS:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 12번
	IDT_OUT_OF_RANGE_OF_SEGMENT:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 13번
	IDT_STACK_SEGMENT_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001
	
	; 14번
	IDT_PROTECTION_RULE_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 15번
	IDT_PAGE_FAULT:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 16번
	IDT_UNDEFINED:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 17번
	IDT_FLOAT_COMPUTATION_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 18번
	IDT_SORTING_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 19번
	IDT_MACHINE_CHECK_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 20번
	IDT_SIMD_ERROR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 21번
	IDT_TIMER:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 22번
	IDT_KEYBOARD:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 23번
	IDT_PIC_CASCADING:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 24번
	IDT_SECOND_SERIAL_PORT:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 25번
	IDT_FIRST_SERIAL_PORT:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 26번
	IDT_PLOPPY_DISK:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 27번
	IDT_SYSTEM_CLOCK:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 28번
	IDT_NETWORK_DEVICE:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 29번
	IDT_USB_PORT_AND_SOUND_CARD:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 30번
	IDT_PS2_MOUSE:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 31번
	IDT_MATH_COPROCESSOR:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 32번
	IDT_EIDE_DISK_CONTROLLER1:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

	; 33번
	IDT_EIDE_DISK_CONTROLLER2:
	dw INTERRUPT_NOTHING
	dw 0x08			
	db 0		
	db 0x8E	 
	dw 0x0001

INTERRUPT_NOTHING:

	; 레지스터 백업
	pushad
	push gs
	push fs
	push es
	push ds
	pushfd

	; 레지스터 복구	
	popfd
	pop ds
	pop es
	pop fs
	pop gs
	popad

	; 기존의 코드로 리턴
	iret

GDTR:
	dw (GDTEND - GDT - 1)
	dd GDT

GDT:
	NULL:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	KCODE:
	dw 0xFFFF ;
	dw 0x0000 ;
	db 0x00 ;
	db 0x9A ;
	db 0xCF ;
	db 0x00 ;

	KDATA:
	dw 0xFFFF ;
	dw 0x0000 ;
	db 0x00 ;
	db 0x92 ;
	db 0xCF ;
	db 0x00 ;

	UCODE:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	UDATA:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00	

	TSS1:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS2:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS3:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS4:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS5:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS6:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS7:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS8:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS9:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS10:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS11:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS12:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS13:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS14:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS15:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

	TSS16:
	dw 0x0000
	dw 0x0000
	db 0x00
	db 0x00
	db 0x00
	db 0x00

GDTEND:
times 2560 - ($ - $$) db 0x00 ; 1024 - (현재 주소에서 섹션 주소의 거리) 이므로 
; 현재 섹션 나머지 부분을 0으로 모두 채운다.
